#if !defined COSISIN_H
#define COSISIN_H

#define BITS        9
#define NR_ENTRIES  (1 << (BITS))
#define BIT(A,N)    (((A) >> (N)) & 1)

#if defined USE_SIN_COS_LOOKUP_TABLE
__constant float2 cosisin_table[NR_ENTRIES] __attribute__((singlepump)) = {
    (float2) (1.f, 0.f),
    (float2) (0.999999f, 0.00153398f),
    (float2) (0.999995f, 0.00306796f),
    (float2) (0.999989f, 0.00460193f),
    (float2) (0.999981f, 0.00613588f),
    (float2) (0.999971f, 0.00766983f),
    (float2) (0.999958f, 0.00920375f),
    (float2) (0.999942f, 0.0107377f),
    (float2) (0.999925f, 0.0122715f),
    (float2) (0.999905f, 0.0138054f),
    (float2) (0.999882f, 0.0153392f),
    (float2) (0.999858f, 0.016873f),
    (float2) (0.999831f, 0.0184067f),
    (float2) (0.999801f, 0.0199404f),
    (float2) (0.999769f, 0.0214741f),
    (float2) (0.999735f, 0.0230077f),
    (float2) (0.999699f, 0.0245412f),
    (float2) (0.99966f, 0.0260747f),
    (float2) (0.999619f, 0.0276081f),
    (float2) (0.999575f, 0.0291415f),
    (float2) (0.999529f, 0.0306748f),
    (float2) (0.999481f, 0.032208f),
    (float2) (0.999431f, 0.0337412f),
    (float2) (0.999378f, 0.0352742f),
    (float2) (0.999322f, 0.0368072f),
    (float2) (0.999265f, 0.0383401f),
    (float2) (0.999205f, 0.0398729f),
    (float2) (0.999142f, 0.0414056f),
    (float2) (0.999078f, 0.0429383f),
    (float2) (0.999011f, 0.0444708f),
    (float2) (0.998941f, 0.0460032f),
    (float2) (0.99887f, 0.0475355f),
    (float2) (0.998795f, 0.0490677f),
    (float2) (0.998719f, 0.0505997f),
    (float2) (0.99864f, 0.0521317f),
    (float2) (0.998559f, 0.0536635f),
    (float2) (0.998476f, 0.0551952f),
    (float2) (0.99839f, 0.0567268f),
    (float2) (0.998302f, 0.0582583f),
    (float2) (0.998211f, 0.0597896f),
    (float2) (0.998118f, 0.0613207f),
    (float2) (0.998023f, 0.0628518f),
    (float2) (0.997925f, 0.0643826f),
    (float2) (0.997825f, 0.0659134f),
    (float2) (0.997723f, 0.0674439f),
    (float2) (0.997618f, 0.0689743f),
    (float2) (0.997511f, 0.0705046f),
    (float2) (0.997402f, 0.0720347f),
    (float2) (0.99729f, 0.0735646f),
    (float2) (0.997176f, 0.0750943f),
    (float2) (0.99706f, 0.0766239f),
    (float2) (0.996941f, 0.0781532f),
    (float2) (0.99682f, 0.0796824f),
    (float2) (0.996697f, 0.0812114f),
    (float2) (0.996571f, 0.0827403f),
    (float2) (0.996443f, 0.0842689f),
    (float2) (0.996313f, 0.0857973f),
    (float2) (0.99618f, 0.0873255f),
    (float2) (0.996045f, 0.0888536f),
    (float2) (0.995907f, 0.0903814f),
    (float2) (0.995767f, 0.091909f),
    (float2) (0.995625f, 0.0934363f),
    (float2) (0.995481f, 0.0949635f),
    (float2) (0.995334f, 0.0964904f),
    (float2) (0.995185f, 0.0980171f),
    (float2) (0.995033f, 0.0995436f),
    (float2) (0.994879f, 0.10107f),
    (float2) (0.994723f, 0.102596f),
    (float2) (0.994565f, 0.104122f),
    (float2) (0.994404f, 0.105647f),
    (float2) (0.99424f, 0.107172f),
    (float2) (0.994075f, 0.108697f),
    (float2) (0.993907f, 0.110222f),
    (float2) (0.993737f, 0.111747f),
    (float2) (0.993564f, 0.113271f),
    (float2) (0.993389f, 0.114795f),
    (float2) (0.993212f, 0.116319f),
    (float2) (0.993032f, 0.117842f),
    (float2) (0.99285f, 0.119365f),
    (float2) (0.992666f, 0.120888f),
    (float2) (0.99248f, 0.122411f),
    (float2) (0.992291f, 0.123933f),
    (float2) (0.992099f, 0.125455f),
    (float2) (0.991906f, 0.126977f),
    (float2) (0.99171f, 0.128498f),
    (float2) (0.991511f, 0.130019f),
    (float2) (0.991311f, 0.13154f),
    (float2) (0.991108f, 0.133061f),
    (float2) (0.990903f, 0.134581f),
    (float2) (0.990695f, 0.136101f),
    (float2) (0.990485f, 0.13762f),
    (float2) (0.990273f, 0.139139f),
    (float2) (0.990058f, 0.140658f),
    (float2) (0.989841f, 0.142177f),
    (float2) (0.989622f, 0.143695f),
    (float2) (0.9894f, 0.145213f),
    (float2) (0.989177f, 0.14673f),
    (float2) (0.98895f, 0.148248f),
    (float2) (0.988722f, 0.149765f),
    (float2) (0.988491f, 0.151281f),
    (float2) (0.988258f, 0.152797f),
    (float2) (0.988022f, 0.154313f),
    (float2) (0.987784f, 0.155828f),
    (float2) (0.987544f, 0.157343f),
    (float2) (0.987301f, 0.158858f),
    (float2) (0.987057f, 0.160372f),
    (float2) (0.986809f, 0.161886f),
    (float2) (0.98656f, 0.1634f),
    (float2) (0.986308f, 0.164913f),
    (float2) (0.986054f, 0.166426f),
    (float2) (0.985798f, 0.167938f),
    (float2) (0.985539f, 0.16945f),
    (float2) (0.985278f, 0.170962f),
    (float2) (0.985014f, 0.172473f),
    (float2) (0.984748f, 0.173984f),
    (float2) (0.98448f, 0.175494f),
    (float2) (0.98421f, 0.177004f),
    (float2) (0.983937f, 0.178514f),
    (float2) (0.983662f, 0.180023f),
    (float2) (0.983385f, 0.181532f),
    (float2) (0.983105f, 0.18304f),
    (float2) (0.982824f, 0.184548f),
    (float2) (0.982539f, 0.186055f),
    (float2) (0.982253f, 0.187562f),
    (float2) (0.981964f, 0.189069f),
    (float2) (0.981673f, 0.190575f),
    (float2) (0.981379f, 0.19208f),
    (float2) (0.981083f, 0.193586f),
    (float2) (0.980785f, 0.19509f),
    (float2) (0.980485f, 0.196595f),
    (float2) (0.980182f, 0.198098f),
    (float2) (0.979877f, 0.199602f),
    (float2) (0.97957f, 0.201105f),
    (float2) (0.97926f, 0.202607f),
    (float2) (0.978948f, 0.204109f),
    (float2) (0.978634f, 0.20561f),
    (float2) (0.978317f, 0.207111f),
    (float2) (0.977998f, 0.208612f),
    (float2) (0.977677f, 0.210112f),
    (float2) (0.977354f, 0.211611f),
    (float2) (0.977028f, 0.21311f),
    (float2) (0.9767f, 0.214609f),
    (float2) (0.97637f, 0.216107f),
    (float2) (0.976037f, 0.217604f),
    (float2) (0.975702f, 0.219101f),
    (float2) (0.975365f, 0.220598f),
    (float2) (0.975025f, 0.222094f),
    (float2) (0.974684f, 0.223589f),
    (float2) (0.974339f, 0.225084f),
    (float2) (0.973993f, 0.226578f),
    (float2) (0.973644f, 0.228072f),
    (float2) (0.973293f, 0.229565f),
    (float2) (0.97294f, 0.231058f),
    (float2) (0.972584f, 0.23255f),
    (float2) (0.972227f, 0.234042f),
    (float2) (0.971866f, 0.235533f),
    (float2) (0.971504f, 0.237024f),
    (float2) (0.971139f, 0.238514f),
    (float2) (0.970772f, 0.240003f),
    (float2) (0.970403f, 0.241492f),
    (float2) (0.970031f, 0.24298f),
    (float2) (0.969657f, 0.244468f),
    (float2) (0.969281f, 0.245955f),
    (float2) (0.968903f, 0.247442f),
    (float2) (0.968522f, 0.248928f),
    (float2) (0.968139f, 0.250413f),
    (float2) (0.967754f, 0.251898f),
    (float2) (0.967366f, 0.253382f),
    (float2) (0.966976f, 0.254866f),
    (float2) (0.966584f, 0.256349f),
    (float2) (0.96619f, 0.257831f),
    (float2) (0.965793f, 0.259313f),
    (float2) (0.965394f, 0.260794f),
    (float2) (0.964993f, 0.262275f),
    (float2) (0.96459f, 0.263755f),
    (float2) (0.964184f, 0.265234f),
    (float2) (0.963776f, 0.266713f),
    (float2) (0.963366f, 0.268191f),
    (float2) (0.962953f, 0.269668f),
    (float2) (0.962538f, 0.271145f),
    (float2) (0.962121f, 0.272621f),
    (float2) (0.961702f, 0.274097f),
    (float2) (0.96128f, 0.275572f),
    (float2) (0.960857f, 0.277046f),
    (float2) (0.960431f, 0.27852f),
    (float2) (0.960002f, 0.279993f),
    (float2) (0.959572f, 0.281465f),
    (float2) (0.959139f, 0.282937f),
    (float2) (0.958703f, 0.284408f),
    (float2) (0.958266f, 0.285878f),
    (float2) (0.957826f, 0.287347f),
    (float2) (0.957385f, 0.288816f),
    (float2) (0.95694f, 0.290285f),
    (float2) (0.956494f, 0.291752f),
    (float2) (0.956045f, 0.293219f),
    (float2) (0.955594f, 0.294685f),
    (float2) (0.955141f, 0.296151f),
    (float2) (0.954686f, 0.297616f),
    (float2) (0.954228f, 0.29908f),
    (float2) (0.953768f, 0.300543f),
    (float2) (0.953306f, 0.302006f),
    (float2) (0.952842f, 0.303468f),
    (float2) (0.952375f, 0.304929f),
    (float2) (0.951906f, 0.30639f),
    (float2) (0.951435f, 0.30785f),
    (float2) (0.950962f, 0.309309f),
    (float2) (0.950486f, 0.310767f),
    (float2) (0.950008f, 0.312225f),
    (float2) (0.949528f, 0.313682f),
    (float2) (0.949046f, 0.315138f),
    (float2) (0.948561f, 0.316593f),
    (float2) (0.948075f, 0.318048f),
    (float2) (0.947586f, 0.319502f),
    (float2) (0.947094f, 0.320955f),
    (float2) (0.946601f, 0.322408f),
    (float2) (0.946105f, 0.323859f),
    (float2) (0.945607f, 0.32531f),
    (float2) (0.945107f, 0.32676f),
    (float2) (0.944605f, 0.32821f),
    (float2) (0.9441f, 0.329658f),
    (float2) (0.943593f, 0.331106f),
    (float2) (0.943084f, 0.332553f),
    (float2) (0.942573f, 0.334f),
    (float2) (0.94206f, 0.335445f),
    (float2) (0.941544f, 0.33689f),
    (float2) (0.941026f, 0.338334f),
    (float2) (0.940506f, 0.339777f),
    (float2) (0.939984f, 0.341219f),
    (float2) (0.939459f, 0.342661f),
    (float2) (0.938932f, 0.344101f),
    (float2) (0.938404f, 0.345541f),
    (float2) (0.937872f, 0.34698f),
    (float2) (0.937339f, 0.348419f),
    (float2) (0.936803f, 0.349856f),
    (float2) (0.936266f, 0.351293f),
    (float2) (0.935726f, 0.352729f),
    (float2) (0.935184f, 0.354164f),
    (float2) (0.934639f, 0.355598f),
    (float2) (0.934093f, 0.357031f),
    (float2) (0.933544f, 0.358463f),
    (float2) (0.932993f, 0.359895f),
    (float2) (0.93244f, 0.361326f),
    (float2) (0.931884f, 0.362756f),
    (float2) (0.931327f, 0.364185f),
    (float2) (0.930767f, 0.365613f),
    (float2) (0.930205f, 0.36704f),
    (float2) (0.929641f, 0.368467f),
    (float2) (0.929075f, 0.369892f),
    (float2) (0.928506f, 0.371317f),
    (float2) (0.927935f, 0.372741f),
    (float2) (0.927363f, 0.374164f),
    (float2) (0.926787f, 0.375586f),
    (float2) (0.92621f, 0.377007f),
    (float2) (0.925631f, 0.378428f),
    (float2) (0.925049f, 0.379847f),
    (float2) (0.924465f, 0.381266f),
    (float2) (0.92388f, 0.382683f),
    (float2) (0.923291f, 0.3841f),
    (float2) (0.922701f, 0.385516f),
    (float2) (0.922109f, 0.386931f),
    (float2) (0.921514f, 0.388345f),
    (float2) (0.920917f, 0.389758f),
    (float2) (0.920318f, 0.39117f),
    (float2) (0.919717f, 0.392582f),
    (float2) (0.919114f, 0.393992f),
    (float2) (0.918508f, 0.395401f),
    (float2) (0.917901f, 0.39681f),
    (float2) (0.917291f, 0.398218f),
    (float2) (0.916679f, 0.399624f),
    (float2) (0.916065f, 0.40103f),
    (float2) (0.915449f, 0.402435f),
    (float2) (0.91483f, 0.403838f),
    (float2) (0.91421f, 0.405241f),
    (float2) (0.913587f, 0.406643f),
    (float2) (0.912962f, 0.408044f),
    (float2) (0.912335f, 0.409444f),
    (float2) (0.911706f, 0.410843f),
    (float2) (0.911075f, 0.412241f),
    (float2) (0.910441f, 0.413638f),
    (float2) (0.909806f, 0.415034f),
    (float2) (0.909168f, 0.41643f),
    (float2) (0.908528f, 0.417824f),
    (float2) (0.907886f, 0.419217f),
    (float2) (0.907242f, 0.420609f),
    (float2) (0.906596f, 0.422f),
    (float2) (0.905947f, 0.42339f),
    (float2) (0.905297f, 0.42478f),
    (float2) (0.904644f, 0.426168f),
    (float2) (0.903989f, 0.427555f),
    (float2) (0.903332f, 0.428941f),
    (float2) (0.902673f, 0.430326f),
    (float2) (0.902012f, 0.431711f),
    (float2) (0.901349f, 0.433094f),
    (float2) (0.900683f, 0.434476f),
    (float2) (0.900016f, 0.435857f),
    (float2) (0.899346f, 0.437237f),
    (float2) (0.898674f, 0.438616f),
    (float2) (0.898001f, 0.439994f),
    (float2) (0.897325f, 0.441371f),
    (float2) (0.896646f, 0.442747f),
    (float2) (0.895966f, 0.444122f),
    (float2) (0.895284f, 0.445496f),
    (float2) (0.894599f, 0.446869f),
    (float2) (0.893913f, 0.448241f),
    (float2) (0.893224f, 0.449611f),
    (float2) (0.892534f, 0.450981f),
    (float2) (0.891841f, 0.45235f),
    (float2) (0.891146f, 0.453717f),
    (float2) (0.890449f, 0.455084f),
    (float2) (0.88975f, 0.456449f),
    (float2) (0.889048f, 0.457813f),
    (float2) (0.888345f, 0.459177f),
    (float2) (0.88764f, 0.460539f),
    (float2) (0.886932f, 0.4619f),
    (float2) (0.886223f, 0.46326f),
    (float2) (0.885511f, 0.464619f),
    (float2) (0.884797f, 0.465977f),
    (float2) (0.884081f, 0.467333f),
    (float2) (0.883363f, 0.468689f),
    (float2) (0.882643f, 0.470043f),
    (float2) (0.881921f, 0.471397f),
    (float2) (0.881197f, 0.472749f),
    (float2) (0.880471f, 0.4741f),
    (float2) (0.879743f, 0.47545f),
    (float2) (0.879012f, 0.476799f),
    (float2) (0.87828f, 0.478147f),
    (float2) (0.877545f, 0.479494f),
    (float2) (0.876809f, 0.480839f),
    (float2) (0.87607f, 0.482184f),
    (float2) (0.875329f, 0.483527f),
    (float2) (0.874587f, 0.484869f),
    (float2) (0.873842f, 0.48621f),
    (float2) (0.873095f, 0.48755f),
    (float2) (0.872346f, 0.488889f),
    (float2) (0.871595f, 0.490227f),
    (float2) (0.870842f, 0.491563f),
    (float2) (0.870087f, 0.492898f),
    (float2) (0.86933f, 0.494232f),
    (float2) (0.868571f, 0.495565f),
    (float2) (0.86781f, 0.496897f),
    (float2) (0.867046f, 0.498228f),
    (float2) (0.866281f, 0.499557f),
    (float2) (0.865514f, 0.500885f),
    (float2) (0.864744f, 0.502212f),
    (float2) (0.863973f, 0.503538f),
    (float2) (0.863199f, 0.504863f),
    (float2) (0.862424f, 0.506187f),
    (float2) (0.861646f, 0.507509f),
    (float2) (0.860867f, 0.50883f),
    (float2) (0.860085f, 0.51015f),
    (float2) (0.859302f, 0.511469f),
    (float2) (0.858516f, 0.512786f),
    (float2) (0.857729f, 0.514103f),
    (float2) (0.856939f, 0.515418f),
    (float2) (0.856147f, 0.516732f),
    (float2) (0.855354f, 0.518044f),
    (float2) (0.854558f, 0.519356f),
    (float2) (0.85376f, 0.520666f),
    (float2) (0.852961f, 0.521975f),
    (float2) (0.852159f, 0.523283f),
    (float2) (0.851355f, 0.52459f),
    (float2) (0.850549f, 0.525895f),
    (float2) (0.849742f, 0.527199f),
    (float2) (0.848932f, 0.528502f),
    (float2) (0.84812f, 0.529804f),
    (float2) (0.847307f, 0.531104f),
    (float2) (0.846491f, 0.532403f),
    (float2) (0.845673f, 0.533701f),
    (float2) (0.844854f, 0.534998f),
    (float2) (0.844032f, 0.536293f),
    (float2) (0.843208f, 0.537587f),
    (float2) (0.842383f, 0.53888f),
    (float2) (0.841555f, 0.540172f),
    (float2) (0.840725f, 0.541462f),
    (float2) (0.839894f, 0.542751f),
    (float2) (0.83906f, 0.544039f),
    (float2) (0.838225f, 0.545325f),
    (float2) (0.837387f, 0.54661f),
    (float2) (0.836548f, 0.547894f),
    (float2) (0.835706f, 0.549177f),
    (float2) (0.834863f, 0.550458f),
    (float2) (0.834018f, 0.551738f),
    (float2) (0.83317f, 0.553017f),
    (float2) (0.832321f, 0.554294f),
    (float2) (0.83147f, 0.55557f),
    (float2) (0.830616f, 0.556845f),
    (float2) (0.829761f, 0.558119f),
    (float2) (0.828904f, 0.559391f),
    (float2) (0.828045f, 0.560662f),
    (float2) (0.827184f, 0.561931f),
    (float2) (0.826321f, 0.563199f),
    (float2) (0.825456f, 0.564466f),
    (float2) (0.824589f, 0.565732f),
    (float2) (0.823721f, 0.566996f),
    (float2) (0.82285f, 0.568259f),
    (float2) (0.821977f, 0.569521f),
    (float2) (0.821102f, 0.570781f),
    (float2) (0.820226f, 0.57204f),
    (float2) (0.819348f, 0.573297f),
    (float2) (0.818467f, 0.574553f),
    (float2) (0.817585f, 0.575808f),
    (float2) (0.816701f, 0.577062f),
    (float2) (0.815814f, 0.578314f),
    (float2) (0.814926f, 0.579565f),
    (float2) (0.814036f, 0.580814f),
    (float2) (0.813144f, 0.582062f),
    (float2) (0.812251f, 0.583309f),
    (float2) (0.811355f, 0.584554f),
    (float2) (0.810457f, 0.585798f),
    (float2) (0.809558f, 0.58704f),
    (float2) (0.808656f, 0.588282f),
    (float2) (0.807753f, 0.589521f),
    (float2) (0.806848f, 0.59076f),
    (float2) (0.80594f, 0.591997f),
    (float2) (0.805031f, 0.593232f),
    (float2) (0.80412f, 0.594467f),
    (float2) (0.803208f, 0.595699f),
    (float2) (0.802293f, 0.596931f),
    (float2) (0.801376f, 0.598161f),
    (float2) (0.800458f, 0.599389f),
    (float2) (0.799537f, 0.600616f),
    (float2) (0.798615f, 0.601842f),
    (float2) (0.797691f, 0.603067f),
    (float2) (0.796765f, 0.60429f),
    (float2) (0.795837f, 0.605511f),
    (float2) (0.794907f, 0.606731f),
    (float2) (0.793975f, 0.60795f),
    (float2) (0.793042f, 0.609167f),
    (float2) (0.792107f, 0.610383f),
    (float2) (0.791169f, 0.611597f),
    (float2) (0.79023f, 0.61281f),
    (float2) (0.789289f, 0.614022f),
    (float2) (0.788346f, 0.615232f),
    (float2) (0.787402f, 0.61644f),
    (float2) (0.786455f, 0.617647f),
    (float2) (0.785507f, 0.618853f),
    (float2) (0.784557f, 0.620057f),
    (float2) (0.783605f, 0.62126f),
    (float2) (0.782651f, 0.622461f),
    (float2) (0.781695f, 0.623661f),
    (float2) (0.780737f, 0.62486f),
    (float2) (0.779778f, 0.626056f),
    (float2) (0.778817f, 0.627252f),
    (float2) (0.777853f, 0.628446f),
    (float2) (0.776888f, 0.629638f),
    (float2) (0.775922f, 0.630829f),
    (float2) (0.774953f, 0.632019f),
    (float2) (0.773983f, 0.633207f),
    (float2) (0.77301f, 0.634393f),
    (float2) (0.772036f, 0.635578f),
    (float2) (0.771061f, 0.636762f),
    (float2) (0.770083f, 0.637944f),
    (float2) (0.769103f, 0.639124f),
    (float2) (0.768122f, 0.640303f),
    (float2) (0.767139f, 0.641481f),
    (float2) (0.766154f, 0.642657f),
    (float2) (0.765167f, 0.643832f),
    (float2) (0.764179f, 0.645005f),
    (float2) (0.763188f, 0.646176f),
    (float2) (0.762196f, 0.647346f),
    (float2) (0.761202f, 0.648514f),
    (float2) (0.760207f, 0.649681f),
    (float2) (0.759209f, 0.650847f),
    (float2) (0.75821f, 0.652011f),
    (float2) (0.757209f, 0.653173f),
    (float2) (0.756206f, 0.654334f),
    (float2) (0.755201f, 0.655493f),
    (float2) (0.754195f, 0.656651f),
    (float2) (0.753187f, 0.657807f),
    (float2) (0.752177f, 0.658961f),
    (float2) (0.751165f, 0.660114f),
    (float2) (0.750152f, 0.661266f),
    (float2) (0.749136f, 0.662416f),
    (float2) (0.748119f, 0.663564f),
    (float2) (0.747101f, 0.664711f),
    (float2) (0.74608f, 0.665856f),
    (float2) (0.745058f, 0.667f),
    (float2) (0.744034f, 0.668142f),
    (float2) (0.743008f, 0.669283f),
    (float2) (0.74198f, 0.670422f),
    (float2) (0.740951f, 0.671559f),
    (float2) (0.73992f, 0.672695f),
    (float2) (0.738887f, 0.673829f),
    (float2) (0.737853f, 0.674962f),
    (float2) (0.736817f, 0.676093f),
    (float2) (0.735779f, 0.677222f),
    (float2) (0.734739f, 0.67835f),
    (float2) (0.733697f, 0.679476f),
    (float2) (0.732654f, 0.680601f),
    (float2) (0.731609f, 0.681724f),
    (float2) (0.730563f, 0.682846f),
    (float2) (0.729514f, 0.683965f),
    (float2) (0.728464f, 0.685084f),
    (float2) (0.727413f, 0.6862f),
    (float2) (0.726359f, 0.687315f),
    (float2) (0.725304f, 0.688429f),
    (float2) (0.724247f, 0.689541f),
    (float2) (0.723188f, 0.690651f),
    (float2) (0.722128f, 0.691759f),
    (float2) (0.721066f, 0.692866f),
    (float2) (0.720002f, 0.693971f),
    (float2) (0.718937f, 0.695075f),
    (float2) (0.71787f, 0.696177f),
    (float2) (0.716801f, 0.697277f),
    (float2) (0.715731f, 0.698376f),
    (float2) (0.714659f, 0.699473f),
    (float2) (0.713585f, 0.700569f),
    (float2) (0.712509f, 0.701663f),
    (float2) (0.711432f, 0.702755f),
    (float2) (0.710353f, 0.703845f),
    (float2) (0.709273f, 0.704934f),
    (float2) (0.708191f, 0.706021f),
};
#endif

float2 cosisin(float arg)
{
#if defined USE_SIN_COS_LOOKUP_TABLE
    uint12_t arg_int = convert_int_rte(arg * (4 * NR_ENTRIES / M_PI_F));
    uint9_t  index   = arg_int /* & (NR_ENTRIES - 1) */;
    uint3_t  octant  = arg_int >> BITS;

    if (BIT(octant, 0)) {
        index = ~index & (NR_ENTRIES - 1);
    }

    float2 val = cosisin_table[index];

    if (BIT(octant, 0) ^ BIT(octant, 1)) {
        val = val.yx;
    }

    if (BIT(octant, 1) ^ BIT(octant, 2)) {
        val.x = -val.x;
    }

    if (BIT(octant, 2)) {
        val.y = -val.y;
    }

    return val;
#else
    return (float2) (cos(arg), sin(arg));
#endif
}

#endif
